commit fbd7bff7112f0353f1bab471cd166369e18ab6a3
Author: freddy77 <freddy77>
Date:   Sun Jan 20 14:23:58 2008 +0000

    port to win64

diff --git a/ChangeLog b/ChangeLog
index 05d433d..468a3bf 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,12 @@
+Sun Jan 20 15:23:16 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac include/tds_sysdep_private.h:
+	* include/tds_sysdep_public.h.in src/apps/Makefile.am:
+	* src/ctlib/unittests/cancel.c src/dblib/unittests/timeout.c:
+	* src/odbc/unittests/describecol.c src/replacements/iconv.c:
+	* src/tds/query.c win32/tds_sysdep_public.h win32/winlogin.c:
+	* win32/winsetup.c:
+	- port to win64
+
 Fri Jan 18 14:33:09 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/odbc/connectparams.c src/tds/config.c:
 	- merge Sebastien Flaesch patch for ODBC parameters
@@ -71,4 +80,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2472 2008/01/18 13:37:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2473 2008/01/20 14:23:58 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index 4a0f729..77740fc 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.32 2008/01/11 12:43:39 freddy77 Exp $
+dnl $Id: configure.ac,v 1.33 2008/01/20 14:23:58 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.32 $)
+AC_REVISION($Revision: 1.33 $)
 
 AM_INIT_AUTOMAKE
 AC_CONFIG_HEADERS(include/config.h)
@@ -142,7 +142,9 @@ tds_mingw=no
 case $host in
 *-*-mingw*)
 	tds_mingw=yes
-	if test -r /usr/lib/w32api/libwsock32.a; then
+	if test "$host_cpu" = "x86_64"; then
+		LIBS="-lws2_32"
+	elif test -r /usr/lib/w32api/libwsock32.a; then
 		LIBS="-L/usr/lib/w32api -lwsock32"
 	else
 		LIBS="-lwsock32"
@@ -381,7 +383,7 @@ TDS_NULL_IS_ZERO
 AC_CHECK_FUNCS([vsnprintf _vsnprintf gettimeofday \
 nl_langinfo locale_charset setenv putenv \
 getuid getpwuid getpwuid_r fstat alarm fork \
-gethrtime localtime_r])
+gethrtime localtime_r setitimer])
 OLD_LIBS="$LIBS"
 LIBS="$LIBS $NETWORK_LIBS"
 AC_CHECK_FUNCS([inet_ntoa_r getipnodebyaddr getipnodebyname \
@@ -474,6 +476,7 @@ if test "$with_odbc_nodm"; then
 	# Can't use ODBCLIB/LDFLAGS variables since they are used in building
 	#  other directories.
 	ODBCNODMLIB="-L.. -ltdsodbc"
+	ODBCNODMLIBAPP="-L../odbc -ltdsodbc"
 	odbc=true
 fi
 
@@ -594,6 +597,7 @@ AC_SUBST(ODBC_INC)
 AC_SUBST(ODBCLIB)
 AC_SUBST(ODBCINSTLIB)
 AC_SUBST(ODBCNODMLIB)
+AC_SUBST(ODBCNODMLIBAPP)
 
 AC_ARG_WITH(gnutls,
 AS_HELP_STRING([--with-gnutls], [build with TLS support]))
diff --git a/include/tds_sysdep_private.h b/include/tds_sysdep_private.h
index 8adfb9b..bce25a0 100644
--- a/include/tds_sysdep_private.h
+++ b/include/tds_sysdep_private.h
@@ -20,7 +20,7 @@
 #ifndef _tds_sysdep_private_h_
 #define _tds_sysdep_private_h_
 
-/* $Id: tds_sysdep_private.h,v 1.24 2008/01/10 22:57:33 jklowden Exp $ */
+/* $Id: tds_sysdep_private.h,v 1.25 2008/01/20 14:23:59 freddy77 Exp $ */
 
 #undef TDS_RCSID
 #if defined(__GNUC__) && __GNUC__ >= 3
@@ -95,6 +95,10 @@ typedef DWORD pid_t;
 #define WIN32 1
 #endif
 
+#if defined(_WIN64) && !defined(WIN64)
+#define WIN64 1
+#endif
+
 #define TDS_SDIR_SEPARATOR "\\"
 
 /* use macros to use new style names */
diff --git a/include/tds_sysdep_public.h.in b/include/tds_sysdep_public.h.in
index 4ab78fb..96a782c 100644
--- a/include/tds_sysdep_public.h.in
+++ b/include/tds_sysdep_public.h.in
@@ -20,7 +20,7 @@
 #ifndef _tds_sysdep_public_h_
 #define _tds_sysdep_public_h_
 
-/* $Id: tds_sysdep_public.h.in,v 1.11 2006/04/12 13:54:10 freddy77 Exp $ */
+/* $Id: tds_sysdep_public.h.in,v 1.12 2008/01/20 14:23:59 freddy77 Exp $ */
 
 #ifdef __cplusplus
 extern "C"
@@ -37,7 +37,11 @@ extern "C"
 #define tds_sysdep_int64_type __int64	/* 64-bit int */
 #define tds_sysdep_real32_type float	/* 32-bit real */
 #define tds_sysdep_real64_type double	/* 64-bit real */
-#define tds_sysdep_intptr_type int	/* 32-bit int */
+#if !defined(WIN64) && !defined(_WIN64)
+#define tds_sysdep_intptr_type int      /* 32-bit int */
+#else
+#define tds_sysdep_intptr_type __int64  /* 64-bit int */
+#endif
 #endif				/* defined(WIN32) || defined(_WIN32) || defined(__WIN32__) */
 
 #ifndef tds_sysdep_int16_type
diff --git a/src/apps/Makefile.am b/src/apps/Makefile.am
index cfa03ac..6b03ce8 100644
--- a/src/apps/Makefile.am
+++ b/src/apps/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.25 2008/01/01 23:09:46 freddy77 Exp $
+# $Id: Makefile.am,v 1.26 2008/01/20 14:23:59 freddy77 Exp $
 
 AM_CPPFLAGS	= -I$(top_srcdir)/include 
 
@@ -28,9 +28,8 @@ bsqldb_LDADD	= ../dblib/libsybdb.la \
 		  $(NETWORK_LIBS)
 
 if ODBC
-bsqlodbc_LDADD	= ../odbc/libtdsodbc.la \
-		  ../replacements/libreplacements.la \
-		  $(ODBCLIB) $(NETWORK_LIBS)
+bsqlodbc_LDADD	= ../replacements/libreplacements.la \
+		  $(ODBCLIB) $(ODBCNODMLIBAPP) $(NETWORK_LIBS)
 bsqlodbc_CPPFLAGS	= $(ODBC_INC) $(AM_CPPFLAGS)
 endif
 
diff --git a/src/ctlib/unittests/cancel.c b/src/ctlib/unittests/cancel.c
index 09f3a1a..74e4da9 100644
--- a/src/ctlib/unittests/cancel.c
+++ b/src/ctlib/unittests/cancel.c
@@ -10,10 +10,10 @@
 #include <ctpublic.h>
 #include "common.h"
 
-static char software_version[] = "$Id: cancel.c,v 1.11 2006/06/15 12:17:47 freddy77 Exp $";
+static char software_version[] = "$Id: cancel.c,v 1.12 2008/01/20 14:23:59 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#ifdef HAVE_ALARM
+#if defined(HAVE_ALARM) && defined(HAVE_SETITIMER)
 
 /* protos */
 int do_fetch(CS_COMMAND * cmd, int *cnt);
diff --git a/src/dblib/unittests/timeout.c b/src/dblib/unittests/timeout.c
index 736f968..7de6013 100644
--- a/src/dblib/unittests/timeout.c
+++ b/src/dblib/unittests/timeout.c
@@ -7,7 +7,7 @@
 #include "common.h"
 #include <time.h>
 
-static char software_version[] = "$Id: timeout.c,v 1.3 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: timeout.c,v 1.4 2008/01/20 14:23:59 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int ntimeouts = 0, ncancels = 0;
@@ -29,7 +29,7 @@ timeout_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char
 		return INT_CANCEL;
 		
 	if (dberr == SYBETIME) {
-		fprintf(stderr, "%d timeouts received in %ld seconds, ", ++ntimeouts, time(NULL) - start_time);
+		fprintf(stderr, "%d timeouts received in %ld seconds, ", ++ntimeouts, (long int) (time(NULL) - start_time));
 		if (ntimeouts > max_timeouts) {
 			if (++ncancels > 1) {
 				fprintf(stderr, "could not timeout cleanly, breaking connection\n");
@@ -73,14 +73,14 @@ timeout_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char
 int 
 chkintr(DBPROCESS * dbproc)
 {
-	printf("in chkintr, %ld seconds elapsed\n", time(NULL) - start_time);
+	printf("in chkintr, %ld seconds elapsed\n", (long int) (time(NULL) - start_time));
 	return FALSE;
 }
 
 int 
 hndlintr(DBPROCESS * dbproc)
 {
-	printf("in hndlintr, %ld seconds elapsed\n", time(NULL) - start_time);
+	printf("in hndlintr, %ld seconds elapsed\n", (long int) (time(NULL) - start_time));
 	return INT_CONTINUE;
 }
 
diff --git a/src/odbc/unittests/describecol.c b/src/odbc/unittests/describecol.c
index cd1de67..3739957 100644
--- a/src/odbc/unittests/describecol.c
+++ b/src/odbc/unittests/describecol.c
@@ -6,7 +6,7 @@
  * test what say SQLDescribeCol about precision using some type
  */
 
-static char software_version[] = "$Id: describecol.c,v 1.13 2007/12/31 10:06:50 freddy77 Exp $";
+static char software_version[] = "$Id: describecol.c,v 1.14 2008/01/20 14:23:59 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
@@ -78,6 +78,9 @@ static struct lookup_int sql_types[] = {
 	TYPE(SQL_BINARY),
 	TYPE(SQL_VARBINARY),
 	TYPE(SQL_LONGVARBINARY),
+	TYPE(SQL_DATE),
+	TYPE(SQL_TIME),
+	TYPE(SQL_TIMESTAMP),
 	TYPE(SQL_TYPE_DATE),
 	TYPE(SQL_TYPE_TIME),
 	TYPE(SQL_TYPE_TIMESTAMP),
@@ -140,7 +143,7 @@ typedef int (*get_attr_t) (ATTR_PARAMS);
 static int
 get_attr_ird(ATTR_PARAMS)
 {
-	SQLINTEGER i;
+	SQLLEN i;
 	SQLRETURN ret;
 
 	if (attr->type == type_CHARP)
diff --git a/src/replacements/iconv.c b/src/replacements/iconv.c
index c709275..80fe192 100644
--- a/src/replacements/iconv.c
+++ b/src/replacements/iconv.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.15 2006/08/07 19:37:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.16 2008/01/20 14:23:59 freddy77 Exp $");
 
 /**
  * \addtogroup conv
@@ -116,7 +116,7 @@ tds_sys_iconv_open (const char* tocode, const char* fromcode)
 	case UTF8_ASCII:
 	case UCS2LE_UTF8:
 	case UTF8_UCS2LE:
-		return (iconv_t)fromto;
+		return (iconv_t) (TDS_INTPTR) fromto;
 		break;
 	default:
 		break;
@@ -144,7 +144,7 @@ tds_sys_iconv (iconv_t cd, const char* * inbuf, size_t *inbytesleft, char* * out
 	int local_errno;
 
 #undef CD
-#define CD ((int)cd)
+#define CD ((int) (TDS_INTPTR) cd)
 
 	/* iconv defines valid semantics for NULL inputs, but we don't support them. */
 	if (!inbuf || !*inbuf || !inbytesleft || !outbuf || !*outbuf || !outbytesleft)
diff --git a/src/tds/query.c b/src/tds/query.c
index 8ef57f7..61c266d 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.217 2008/01/05 11:24:40 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.218 2008/01/20 14:23:59 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -1729,7 +1729,7 @@ tds_get_dynid(TDSSOCKET * tds, char **id)
 
 	inc_num = (inc_num + 1) & 0xffff;
 	/* some version of Sybase require length <= 10, so we code id */
-	n = (unsigned long) tds;
+	n = (unsigned long) (TDS_INTPTR) tds;
 	if (!(p = (char *) malloc(16)))
 		return TDS_FAIL;
 	*id = p;
diff --git a/win32/tds_sysdep_public.h b/win32/tds_sysdep_public.h
index 048c409..d86e324 100644
--- a/win32/tds_sysdep_public.h
+++ b/win32/tds_sysdep_public.h
@@ -20,7 +20,7 @@
 #ifndef _tds_sysdep_public_h_
 #define _tds_sysdep_public_h_
 
-static char rcsid_tds_sysdep_public_h[] = "$Id: tds_sysdep_public.h,v 1.5 2004/02/03 19:28:12 jklowden Exp $";
+static char rcsid_tds_sysdep_public_h[] = "$Id: tds_sysdep_public.h,v 1.6 2008/01/20 14:23:59 freddy77 Exp $";
 static void *no_unused_tds_sysdep_public_h_warn[] = { rcsid_tds_sysdep_public_h, no_unused_tds_sysdep_public_h_warn };
 
 #ifdef __cplusplus
@@ -34,12 +34,23 @@ extern "C"
 #define tds_sysdep_int64_type __int64	/* 64-bit int */
 #define tds_sysdep_real32_type float	/* 32-bit real */
 #define tds_sysdep_real64_type double	/* 64-bit real */
+#if !defined(WIN64) && !defined(_WIN64)
 #define tds_sysdep_intptr_type int	/* 32-bit int */
+#else
+#define tds_sysdep_intptr_type __int64	/* 64-bit int */
+#endif
 typedef SOCKET TDS_SYS_SOCKET;
 #ifndef TDS_IS_SOCKET_INVALID
 #define TDS_IS_SOCKET_INVALID(s) ((s) == INVALID_SOCKET)
 #endif
 
+#if !defined(MSDBLIB) && !defined(SYBDBLIB)
+#define SYBDBLIB 1
+#endif
+#if defined(MSDBLIB) && defined(SYBDBLIB)
+#error MSDBLIB and SYBDBLIB cannot both be defined
+#endif
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/win32/winlogin.c b/win32/winlogin.c
index 4a2c2aa..9e5969d 100644
--- a/win32/winlogin.c
+++ b/win32/winlogin.c
@@ -88,6 +88,14 @@ get_desktop_file(const char *file)
 	return res;
 }
 
+#ifndef WIN64
+#define GetWindowUserData(wnd)       GetWindowLong((wnd), GWL_USERDATA)
+#define SetWindowUserData(wnd, data) SetWindowLong((wnd), GWL_USERDATA, (data))
+#else
+#define GetWindowUserData(wnd)       GetWindowLongPtr((wnd), GWLP_USERDATA)
+#define SetWindowUserData(wnd, data) SetWindowLongPtr((wnd), GWLP_USERDATA, (data))
+#endif
+
 /**
  * Callback function for the DSN Configuration dialog 
  * \param hDlg identifies the dialog
@@ -107,7 +115,7 @@ LoginDlgProc(HWND hDlg, UINT message, WPARAM wParam,	/* */
 	case WM_INITDIALOG:
 		/* lParam points to the TDSCONNECTION */
 		connection = (TDSCONNECTION *) lParam;
-		SetWindowLong(hDlg, GWL_USERDATA, lParam);
+		SetWindowUserData(hDlg, lParam);
 
 		/* copy info from TDSCONNECTION to the dialog */
 		SendDlgItemMessage(hDlg, IDC_LOGINSERVER, WM_SETTEXT, 0, (LPARAM) tds_dstr_cstr(&connection->server_name));
@@ -122,7 +130,7 @@ LoginDlgProc(HWND hDlg, UINT message, WPARAM wParam,	/* */
 
 	case WM_COMMAND:
 		/* Dialog's user data points to TDSCONNECTION */
-		connection = (TDSCONNECTION *) GetWindowLong(hDlg, GWL_USERDATA);
+		connection = (TDSCONNECTION *) GetWindowUserData(hDlg);
 
 		/* The wParam indicates which button was pressed */
 		if (LOWORD(wParam) == IDCANCEL) {
diff --git a/win32/winsetup.c b/win32/winsetup.c
index 20585f0..e33dc76 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -192,6 +192,13 @@ validate(DSNINFO * di)
 	return NULL;
 }
 
+#ifndef WIN64
+#define GetWindowUserData(wnd)       GetWindowLong((wnd), GWL_USERDATA)
+#define SetWindowUserData(wnd, data) SetWindowLong((wnd), GWL_USERDATA, (data))
+#else
+#define GetWindowUserData(wnd)       GetWindowLongPtr((wnd), GWLP_USERDATA)
+#define SetWindowUserData(wnd, data) SetWindowLongPtr((wnd), GWLP_USERDATA, (data))
+#endif
 
 /** 
  * Callback function for the DSN Configuration dialog
@@ -216,7 +223,7 @@ DSNDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 	case WM_INITDIALOG:
 		/* lParam points to the DSNINFO */
 		di = (DSNINFO *) lParam;
-		SetWindowLong(hDlg, GWL_USERDATA, lParam);
+		SetWindowUserData(hDlg, lParam);
 
 		/* Stuff legal protocol names into IDC_PROTOCOL */
 		for (i = 0; protocols[i]; i++) {
@@ -236,7 +243,7 @@ DSNDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 
 	case WM_COMMAND:
 		/* Dialog's user data points to DSNINFO */
-		di = (DSNINFO *) GetWindowLong(hDlg, GWL_USERDATA);
+		di = (DSNINFO *) GetWindowUserData(hDlg);
 
 		/* The wParam indicates which button was pressed */
 		if (LOWORD(wParam) == IDCANCEL) {

